#!/bin/sh
###
PATH=/bin:/sbin:/usr/bin:/usr/ucb:/usr/sbin:/usr/local/bin:/usr/local/sbin
export PATH

INETD=/etc/inetd.conf
OS=`uname`

case $OS in
'HP-UX')
	RCPATH=/sbin/init.d
	Ssendmail=iscansmtps
	Sftp=iscanftps
	Shttp=iscanhttpproxys
	;;
'OSF1')
	RCPATH=/sbin/init.d
	Ssendmail=sendmail
	Sftp=iscanftps
	Shttp=iscanhttpproxys
	;;
'Linux')
        RCPATH=/etc/iscan
	Ssendmail=iscansmtps
	Sftp=iscanftps
	Shttp=iscanhttpproxys
	;;
'AIX')
#	RCPATH=/etc/rc.d/rc2.d
	RCPATH=/etc/rc.iscan
#	RCFILE_ORIG=/etc/rc.issmtp
	Ssendmail=rc.issmtp
	Sftp=rc.isftp
	Shttp=rc.isproxy
;;
*)
        RCPATH=/etc/iscan
        Ssendmail=S88sendmail
        Sftp=S99ISftp
        Shttp=S99ISproxy
	;;
esac

case $1 in
"mail" )
	RCFILE=`awk 'BEGIN { FS="=" } /^rc_path/{ print $2 }' < /etc/iscan/intscan.ini`
	if [ "$RCFILE_ORIG" != "" -a "$RCFILE" = "" ] ; then
		RCFILE=$RCFILE_ORIG
	fi

	if [ "$RCFILE" != "" ] ; then
		$RCFILE stop > /dev/null
	else
		$RCPATH/$Ssendmail stop > /dev/null
	fi
	echo 0 > /etc/iscan/pkg/ISSMTPON
	;;
"http" )
	echo 0 > /etc/iscan/pkg/ISHTTPON
	$RCPATH/$Shttp stop > /dev/null
	;;
"cvp" )
	echo 0 > /etc/iscan/pkg/ISCVPON
	$RCPATH/S99IScvp stop > /dev/null 
	;;
"ftp" )
	echo 0 > /etc/iscan/pkg/ISFTPON
	$RCPATH/$Sftp stop > /dev/null
	if [ "$OS" = "Linux" ] ; then
	    XINETDPID=`ps ax | grep xinetd | grep -v grep | awk '{ print $1}'`
	else
	    XINETDPID=`ps -e | grep xinetd | grep -v grep | awk '{ print $1}'`
	fi
	if [ $XINETDPID ] ; then
	    XDIR=`grep includedir /etc/xinetd.conf | awk '{ print $2 }'`
            if [ -d /etc/iscan/.xinetd ] ; then
                ls -1 /etc/iscan/.xinetd > /tmp/xinet_tmp.$$
                while read RLINE
                do
                    mv "/etc/iscan/.xinetd/$RLINE" $XDIR
                done < /tmp/xinet_tmp.$$
                rm -f /tmp/xinet_tmp.$$
            fi
	    
	    if [ $XINETDPID ] ; then
		kill -USR2 $XINETDPID
	    fi
	else
	    status=`grep "#_ISCAN_" $INETD` > /dev/null
	    if [ $? -eq 0 ] ; then
		sed  "s/#_ISCAN_ //g" $INETD > /tmp/tmp$$
		cat /tmp/tmp$$ > $INETD
		rm -f /tmp/tmp$$
		if [ "$OS" = "Linux" ] ; then
		    INETDPID=`ps ax | grep inetd | grep -v grep | awk '{ print $1}'`
		else
			INETDPID=`ps -e | grep inetd | grep -v grep | awk '{ print $1}'`
		fi
		if [ $INETDPID ] ; then
		    kill -1 $INETDPID
		    sleep 3
		fi
	    fi
	fi
	;;
esac


