#!/bin/sh
###
PATH=/bin:/sbin:/usr/bin:/usr/ucb:/usr/sbin:/usr/local/bin:/usr/local/sbin
export PATH

INETD=/etc/inetd.conf
OS=`uname`

case $OS in
'HP-UX')
	RCPATH=/sbin/init.d
	Ssendmail=iscansmtps
	Sftp=iscanftps
	Shttp=iscanhttpproxys
	;;
'OSF1')
	RCPATH=/sbin/init.d
	Ssendmail=sendmail
	Sftp=iscanftps
	Shttp=iscanhttpproxys
	;;
'Linux')
        RCPATH=/etc/iscan
	Ssendmail=iscansmtps
	Sftp=iscanftps
	Shttp=iscanhttpproxys
	;;
'AIX')
	RCPATH=/etc/rc.iscan
	Ssendmail=rc.issmtp
	Sftp=rc.isftp
	Shttp=rc.isproxy
	;;
*)
	RCPATH=/etc/iscan
	Ssendmail=S88sendmail
	Sftp=S99ISftp
	Shttp=S99ISproxy
	;;
esac

case $1 in 
"mail" )

	RCFILE=`awk 'BEGIN { FS="=" } /^rc_path/{ print $2 }' < /etc/iscan/intscan.ini`
	if [ "$RCFILE_ORIG" != "" -a "$RCFILE" = "" ] ; then
		RCFILE=$RCFILE_ORIG
	fi

	if [ "$RCFILE" != "" ] ; then
		$RCFILE stop > /dev/null
	else
		$RCPATH/$Ssendmail stop > /dev/null
	fi
	echo 1 > /etc/iscan/pkg/ISSMTPON
	if [ "$RCFILE" != "" ] ; then
		$RCFILE start > /dev/null
	else
		$RCPATH/$Ssendmail start > /dev/null
	fi
	;;
"http" )
	$RCPATH/$Shttp stop > /dev/null
	echo 1 > /etc/iscan/pkg/ISHTTPON
	$RCPATH/$Shttp start > /dev/null
	;;
"cvp" )
	$RCPATH/S99IScvp stop > /dev/null 
        echo 1 > /etc/iscan/pkg/ISCVPON
	$RCPATH/S99IScvp start > /dev/null
        ;;
"ftp" ) 
echo 1 > /etc/iscan/pkg/ISFTPON
if [ "$OS" = "Linux" ] ; then
      XINETDPID=`ps ax | grep xinetd | grep -v grep | awk '{ print $1}'`
else
      XINETDPID=`ps -e | grep xinetd | grep -v grep | awk '{ print $1}'`
fi
if [ $XINETDPID ] ; then
    XDIR=`grep includedir /etc/xinetd.conf | awk '{ print $2 }'`
    ls -1 $XDIR > /tmp/xinet_tmp.$$
    if [ ! -d /etc/iscan/.xinetd ] ; then
        mkdir /etc/iscan/.xinetd
    fi
    while read RLINE
    do
        SERV=`grep service "$XDIR/$RLINE" | awk '{ print $2 }'`
        if [[ "$SERV" = "ftp" || "$SERV" = "25" ]] ; then
            mv "$XDIR/$RLINE" "/etc/iscan/.xinetd/$RLINE"
        fi
    done < /tmp/xinet_tmp.$$
    rm -f /tmp/xinet_tmp.$$
    if [ $XINETDPID ] ; then
        kill -USR2 $XINETDPID
    fi
else
grep "#_ISCAN_" $INETD > /dev/null
if [ $? -eq 1 ] ; then
#	sed "s/^[ 	]*ftp/#_ISCAN_ ftp/" $INETD > /tmp/tmp$$
	sed -e "s/^\(ftp[ 	]*stream[ 	]*tcp[46 	]\)/#_ISCAN_ \1/" $INETD > /tmp/tmp$$
	cat /tmp/tmp$$ > $INETD
	rm -f /tmp/tmp$$
	if [ "$OS" = "Linux" ] ; then
	    INETDPID=`ps ax | grep inetd | grep -v grep | awk '{ print $1}'`
	else
	    INETDPID=`ps -e | grep inetd | grep -v grep | awk '{ print $1}'`
	fi
	if [ $INETDPID ] ; then
		kill -HUP $INETDPID
		sleep 3
	fi
fi
fi
$RCPATH/$Sftp start > /dev/null
;;
esac


