#!/bin/csh -f
#
# 
set PROGRAM = "Environment  Collector for ActiveSupport"
set VERSION = "1.0"
set COPYRIGHT = "Copyright (c) 2000 Trend Mirco Incorporated. All right reserved."

set path = ( /bin /usr/bin /usr/sbin /sbin . $path )

unsetenv LANG

# Environment Variables
#
set ISCAN   = "/etc/iscan"
set PKGPATH = ${ISCAN}/pkg
set SMTPD   = ${ISCAN}/sendmail
set FTPD    = ${ISCAN}/isftpd
set HTTPD   = ${ISCAN}/ishttpd
set CVP     = ${ISCAN}/iscvp
set INIFILE = ${ISCAN}/intscan.ini

set ISVWROOT = `cat ${PKGPATH}/ISVWROOT`
set CGIPATH = ${ISVWROOT}/ISADMIN/IScan.adm/cgi-bin
set BASEPATH = ${ISVWROOT}/ISBASE/IScan.BASE

set GETENG  = ${ISCAN}/geteng
set GETCONF = ${ISCAN}/getconf

# For 3.5 compatible
if ( ! -x ${GETENG} ) then
	set GETENG = ${CGIPATH}/geteng
endif

# Header and Copyright
#
echo "#"
echo "#  ${PROGRAM} Version ${VERSION}"
echo "#"
echo "#        ${COPYRIGHT}"
echo ""

# Platform Information
#
set UNAME = "uname -a"
set IFCON = "ifconfig"
set DF    = "df -k"
set OS = `uname`
switch (${OS})
case "HP-UX":
  set IFOPT = `lanscan -i`
  breaksw
default:
  set IFOPT = "-a"
  breaksw
endsw

echo "Platform Information:"
echo ""
echo "    # ${UNAME}:"
          ${UNAME}
if ( ${OS} == "Linux" ) then
	cat /etc/issue.net
endif
echo ""
echo "    # ${IFCON} ${IFOPT}:"
          ${IFCON} ${IFOPT}
echo ""
echo "    # ${DF}:"
          ${DF}
echo ""

# InterScan VirusWall for UNIX Information
#
if ( -x ${GETCONF} ) then
  set PATPATH = `${GETCONF} Scan-configuration pattern_path`
else
  set PATPATH = `grep pattern_path $INIFILE | cut -d= -f2`
endif

echo "InterScan VirusWall for UNIX Information:"
echo ""

set  version = `${GETENG} "Scan Engine: "`
echo "	${version}"

set  version = `${GETENG} "Pattern Number: " ${PATPATH}`
echo "	${version}"

echo "	Macro Pattern Files:"
(cd ${BASEPATH}; ls -la mac* | awk '{printf "\t\t%10d %3s %2s %s %s\n",$5,$6,$7,$8,$9}')

if ( -f ${PKGPATH}/ISSMTP && -x ${SMTPD} ) then
	set  version = `${SMTPD} -v | cut -d' ' -f2`
	echo "	SMTP Version: $version"
endif

if ( -f ${PKGPATH}/ISHTTP && -x ${HTTPD} ) then
	set  version = `${HTTPD} -v | cut -d' ' -f2`
	echo "	HTTP Version: $version"
endif

if ( -f ${PKGPATH}/ISFTP && -x ${FTPD} ) then
	set  version = `${FTPD} -v | cut -d' ' -f2`
	echo "	FTP  Version: $version"
endif

if ( -f ${PKGPATH}/ISCVP && -x ${CVP} ) then
	set  version = `${CVP} -v | cut -d' ' -f2`
	echo "	CVP Version: $version"
endif
echo ""

# Original sendmail Information
#
echo "Original sendmail Information:"
echo ""

set program = "/dev/null"

if ( -x ${GETCONF} ) then
  if ( `${GETCONF} smtp local_mode` == "yes" ) then
    set program = `${GETCONF} smtp command_param | cut -d' ' -f1`
  endif
else
  set program = `grep ^original ${INIFILE} | tail -1 | cut -d= -f2 | cut -d' ' -f1`
endif

if ( -x ${program} ) then
  echo "    # ${program}"
  echo ""
  set version = `${program} -db < /dev/null | head -1`
  echo "	${version}"
else
  echo "    # Not use in localhost"
endif
echo ""

exit 0

