#!/bin/sh
###     $Date: 1999/11/10 03:28:54 $
###     $Author: jtani $
###     $Revision: 1.4 $
###     $Id: daemonhup.sh,v 1.4 1999/11/10 03:28:54 jtani Exp $
###     $Log: daemonhup.sh,v $
###     Revision 1.4  1999/11/10 03:28:54  jtani
###     Fix IS_KILL->$IS_KILL for cvp only.(Patch4)
###
###     Revision 1.3  1999/06/09 03:48:59  jtani
###     Fix PID,PPID judge.
###
###     Revision 1.2  1999/05/27 10:22:28  iscanadm
###     Support on Linux.
###
###     Revision 1.1  1998/06/12 21:21:27  ychang
###     Initial revision
###
###

PATH=/usr/bin:/bin
OS=`uname`

if [ "$1" = "sendmail" -o "$1" = "isftpd" -o "$1" = "ishttpd" -o "$1" = "iscvp" ] ; then
	service=$1
else
	exit 1
fi
#echo $service

### set command
IS_AWK="awk"
IS_GREP="grep"
IS_KILL="kill"
IS_PIDC1="\$2"
if [ "$OS" = "Linux" ] ; then
    IS_PS="ps jax"
    IS_PIDC2="\$2,\$1"
else
    IS_PS="ps -ef"
    IS_PIDC2="\$2,\$3"
fi

#### for cvp only
if [ "$service" = "iscvp" ]
then
    cvpid=`$IS_PS | $IS_GREP iscvp | $IS_GREP -v grep | $IS_GREP -v daemonhup.sh| $IS_AWK '{ print '"$IS_PIDC1"' }'`
    if [ -n "$cvpid" ]
    then
        $IS_KILL -HUP $cvpid  > /dev/null 2>&1
#       echo $cvpid
    fi
    exit 0 
fi

#### for HTTP only
if [ "$service" = "ishttpd" ]; then
	PID_FILE=/etc/iscan/pids/${service}.pid
	if [ -f $PID_FILE ]; then
		$IS_KILL -HUP `cat /etc/iscan/pids/${service}.pid`
	fi
	exit 0
fi

cnt="0"
for i in `$IS_PS | $IS_GREP /etc/iscan/$service | $IS_GREP -v grep | $IS_AWK '{ print '"$IS_PIDC2"' }'`
do 
    if [ $cnt = "0" ]
    then
        pid=$i
        cnt="1"
    else
        ppid=$i
        cnt="2"
    fi
    if [ $cnt = "2" ]
    then
#       echo "pass1:$ppid-$pid"
        if [ $ppid = "1" ]
        then
            is_ppid=$pid
        fi
        cnt="0"
    fi
done
#echo "$1 parent id $is_ppid"
for i in `$IS_PS | $IS_GREP /etc/iscan/$service | $IS_GREP -v grep | $IS_AWK '{ print '"$IS_PIDC1"' }'`
do
#   echo "pass2:$i"
    if [ $i -ne $is_ppid ]
    then
#       echo "kill:$i"
        $IS_KILL -HUP $i > /dev/null 2>&1
    fi
done

############### Original code ###############
##
#### for cvp only
##if [ "$service" = "iscvp" ] ; then
##    if [ "$OS" = "Linux" ] ; then
##	cvpid=`ps jax --sort=-ppid | grep iscvp | grep -v grep | grep -v daemonhup.sh| awk '{ print $2}'`
##	if [ -n "$cvpid" ] 
##	then
##	       	kill -HUP $cvpid
##		# echo $cvpid
##	fi
##	exit 0 
##    else
##	cvpid=`ps -ef | grep iscvp | grep -v grep | grep -v daemonhup.sh| awk '{ print $2}'`
##	if [ -n "$cvpid" ] 
##	then
##	       	kill -HUP $cvpid
##		# echo $cvpid
##	fi
##	exit 0 
##    fi
##fi	
##
##if [ "$OS" = "Linux" ] ; then
##    for i in `ps jax --sort=-ppid | grep /etc/iscan/$service | grep -v grep | awk '{ print $1}'`
##	do 
##	   if [ $i -ne 1 ] ; then
##		p=$i
##	   fi
##        done
##else
##    for i in `ps -ef | grep /etc/iscan/$service | grep -v grep | awk '{ print $3}'`
##	do 
##	   if [ $i -ne 1 ] ; then
##		p=$i
##	   fi
##        done
##fi
##
##if  test "$p"   
##then 
##    # echo "$1 parent id $p "  
##    if [ "$OS" = "Linux" ] ; then
##    for i in `ps jax --sort=-ppid | grep /etc/iscan/$service | grep -v grep | awk '{ print $2}'`
##	do
##	    if [ $i -ne $p ] ; then 
##		kill -HUP $i
##            fi
##	done
##    else
##    for i in `ps -ef | grep /etc/iscan/$service | grep -v grep | awk '{ print $2}'`
##	do
##	    if [ $i -ne $p ] ; then 
##		kill -HUP $i
##            fi
##	done
##    fi
##fi
